<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFormFieldSchemaContract ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFormFieldSchemaContract
 * @subpackage Arrays
 */
class ArrayOfFormFieldSchemaContract extends AbstractStructArrayBase
{
    /**
     * The FormFieldSchemaContract
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FormFieldSchemaContract[]
     */
    public $FormFieldSchemaContract;
    /**
     * Constructor method for ArrayOfFormFieldSchemaContract
     * @uses ArrayOfFormFieldSchemaContract::setFormFieldSchemaContract()
     * @param \StructType\FormFieldSchemaContract[] $formFieldSchemaContract
     */
    public function __construct(array $formFieldSchemaContract = array())
    {
        $this
            ->setFormFieldSchemaContract($formFieldSchemaContract);
    }
    /**
     * Get FormFieldSchemaContract value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FormFieldSchemaContract[]|null
     */
    public function getFormFieldSchemaContract()
    {
        return isset($this->FormFieldSchemaContract) ? $this->FormFieldSchemaContract : null;
    }
    /**
     * Set FormFieldSchemaContract value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FormFieldSchemaContract[] $formFieldSchemaContract
     * @return \ArrayType\ArrayOfFormFieldSchemaContract
     */
    public function setFormFieldSchemaContract(array $formFieldSchemaContract = array())
    {
        foreach ($formFieldSchemaContract as $arrayOfFormFieldSchemaContractFormFieldSchemaContractItem) {
            // validation for constraint: itemType
            if (!$arrayOfFormFieldSchemaContractFormFieldSchemaContractItem instanceof \StructType\FormFieldSchemaContract) {
                throw new \InvalidArgumentException(sprintf('The FormFieldSchemaContract property can only contain items of \StructType\FormFieldSchemaContract, "%s" given', is_object($arrayOfFormFieldSchemaContractFormFieldSchemaContractItem) ? get_class($arrayOfFormFieldSchemaContractFormFieldSchemaContractItem) : gettype($arrayOfFormFieldSchemaContractFormFieldSchemaContractItem)), __LINE__);
            }
        }
        if (is_null($formFieldSchemaContract) || (is_array($formFieldSchemaContract) && empty($formFieldSchemaContract))) {
            unset($this->FormFieldSchemaContract);
        } else {
            $this->FormFieldSchemaContract = $formFieldSchemaContract;
        }
        return $this;
    }
    /**
     * Add item to FormFieldSchemaContract value
     * @throws \InvalidArgumentException
     * @param \StructType\FormFieldSchemaContract $item
     * @return \ArrayType\ArrayOfFormFieldSchemaContract
     */
    public function addToFormFieldSchemaContract(\StructType\FormFieldSchemaContract $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FormFieldSchemaContract) {
            throw new \InvalidArgumentException(sprintf('The FormFieldSchemaContract property can only contain items of \StructType\FormFieldSchemaContract, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FormFieldSchemaContract[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FormFieldSchemaContract|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FormFieldSchemaContract|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FormFieldSchemaContract|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FormFieldSchemaContract|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FormFieldSchemaContract|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FormFieldSchemaContract
     */
    public function getAttributeName()
    {
        return 'FormFieldSchemaContract';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfFormFieldSchemaContract
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
