<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGridFieldSchemaContract ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGridFieldSchemaContract
 * @subpackage Arrays
 */
class ArrayOfGridFieldSchemaContract extends AbstractStructArrayBase
{
    /**
     * The GridFieldSchemaContract
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GridFieldSchemaContract[]
     */
    public $GridFieldSchemaContract;
    /**
     * Constructor method for ArrayOfGridFieldSchemaContract
     * @uses ArrayOfGridFieldSchemaContract::setGridFieldSchemaContract()
     * @param \StructType\GridFieldSchemaContract[] $gridFieldSchemaContract
     */
    public function __construct(array $gridFieldSchemaContract = array())
    {
        $this
            ->setGridFieldSchemaContract($gridFieldSchemaContract);
    }
    /**
     * Get GridFieldSchemaContract value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GridFieldSchemaContract[]|null
     */
    public function getGridFieldSchemaContract()
    {
        return isset($this->GridFieldSchemaContract) ? $this->GridFieldSchemaContract : null;
    }
    /**
     * Set GridFieldSchemaContract value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GridFieldSchemaContract[] $gridFieldSchemaContract
     * @return \ArrayType\ArrayOfGridFieldSchemaContract
     */
    public function setGridFieldSchemaContract(array $gridFieldSchemaContract = array())
    {
        foreach ($gridFieldSchemaContract as $arrayOfGridFieldSchemaContractGridFieldSchemaContractItem) {
            // validation for constraint: itemType
            if (!$arrayOfGridFieldSchemaContractGridFieldSchemaContractItem instanceof \StructType\GridFieldSchemaContract) {
                throw new \InvalidArgumentException(sprintf('The GridFieldSchemaContract property can only contain items of \StructType\GridFieldSchemaContract, "%s" given', is_object($arrayOfGridFieldSchemaContractGridFieldSchemaContractItem) ? get_class($arrayOfGridFieldSchemaContractGridFieldSchemaContractItem) : gettype($arrayOfGridFieldSchemaContractGridFieldSchemaContractItem)), __LINE__);
            }
        }
        if (is_null($gridFieldSchemaContract) || (is_array($gridFieldSchemaContract) && empty($gridFieldSchemaContract))) {
            unset($this->GridFieldSchemaContract);
        } else {
            $this->GridFieldSchemaContract = $gridFieldSchemaContract;
        }
        return $this;
    }
    /**
     * Add item to GridFieldSchemaContract value
     * @throws \InvalidArgumentException
     * @param \StructType\GridFieldSchemaContract $item
     * @return \ArrayType\ArrayOfGridFieldSchemaContract
     */
    public function addToGridFieldSchemaContract(\StructType\GridFieldSchemaContract $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GridFieldSchemaContract) {
            throw new \InvalidArgumentException(sprintf('The GridFieldSchemaContract property can only contain items of \StructType\GridFieldSchemaContract, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->GridFieldSchemaContract[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GridFieldSchemaContract|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GridFieldSchemaContract|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GridFieldSchemaContract|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GridFieldSchemaContract|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GridFieldSchemaContract|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GridFieldSchemaContract
     */
    public function getAttributeName()
    {
        return 'GridFieldSchemaContract';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfGridFieldSchemaContract
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
