<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGridSchemaContract ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGridSchemaContract
 * @subpackage Arrays
 */
class ArrayOfGridSchemaContract extends AbstractStructArrayBase
{
    /**
     * The GridSchemaContract
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GridSchemaContract[]
     */
    public $GridSchemaContract;
    /**
     * Constructor method for ArrayOfGridSchemaContract
     * @uses ArrayOfGridSchemaContract::setGridSchemaContract()
     * @param \StructType\GridSchemaContract[] $gridSchemaContract
     */
    public function __construct(array $gridSchemaContract = array())
    {
        $this
            ->setGridSchemaContract($gridSchemaContract);
    }
    /**
     * Get GridSchemaContract value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GridSchemaContract[]|null
     */
    public function getGridSchemaContract()
    {
        return isset($this->GridSchemaContract) ? $this->GridSchemaContract : null;
    }
    /**
     * Set GridSchemaContract value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GridSchemaContract[] $gridSchemaContract
     * @return \ArrayType\ArrayOfGridSchemaContract
     */
    public function setGridSchemaContract(array $gridSchemaContract = array())
    {
        foreach ($gridSchemaContract as $arrayOfGridSchemaContractGridSchemaContractItem) {
            // validation for constraint: itemType
            if (!$arrayOfGridSchemaContractGridSchemaContractItem instanceof \StructType\GridSchemaContract) {
                throw new \InvalidArgumentException(sprintf('The GridSchemaContract property can only contain items of \StructType\GridSchemaContract, "%s" given', is_object($arrayOfGridSchemaContractGridSchemaContractItem) ? get_class($arrayOfGridSchemaContractGridSchemaContractItem) : gettype($arrayOfGridSchemaContractGridSchemaContractItem)), __LINE__);
            }
        }
        if (is_null($gridSchemaContract) || (is_array($gridSchemaContract) && empty($gridSchemaContract))) {
            unset($this->GridSchemaContract);
        } else {
            $this->GridSchemaContract = $gridSchemaContract;
        }
        return $this;
    }
    /**
     * Add item to GridSchemaContract value
     * @throws \InvalidArgumentException
     * @param \StructType\GridSchemaContract $item
     * @return \ArrayType\ArrayOfGridSchemaContract
     */
    public function addToGridSchemaContract(\StructType\GridSchemaContract $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GridSchemaContract) {
            throw new \InvalidArgumentException(sprintf('The GridSchemaContract property can only contain items of \StructType\GridSchemaContract, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->GridSchemaContract[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GridSchemaContract|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GridSchemaContract|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GridSchemaContract|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GridSchemaContract|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GridSchemaContract|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GridSchemaContract
     */
    public function getAttributeName()
    {
        return 'GridSchemaContract';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfGridSchemaContract
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
