<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHmisFormDataContract ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfHmisFormDataContract
 * @subpackage Arrays
 */
class ArrayOfHmisFormDataContract extends AbstractStructArrayBase
{
    /**
     * The HmisFormDataContract
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\HmisFormDataContract[]
     */
    public $HmisFormDataContract;
    /**
     * Constructor method for ArrayOfHmisFormDataContract
     * @uses ArrayOfHmisFormDataContract::setHmisFormDataContract()
     * @param \StructType\HmisFormDataContract[] $hmisFormDataContract
     */
    public function __construct(array $hmisFormDataContract = array())
    {
        $this
            ->setHmisFormDataContract($hmisFormDataContract);
    }
    /**
     * Get HmisFormDataContract value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\HmisFormDataContract[]|null
     */
    public function getHmisFormDataContract()
    {
        return isset($this->HmisFormDataContract) ? $this->HmisFormDataContract : null;
    }
    /**
     * Set HmisFormDataContract value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\HmisFormDataContract[] $hmisFormDataContract
     * @return \ArrayType\ArrayOfHmisFormDataContract
     */
    public function setHmisFormDataContract(array $hmisFormDataContract = array())
    {
        foreach ($hmisFormDataContract as $arrayOfHmisFormDataContractHmisFormDataContractItem) {
            // validation for constraint: itemType
            if (!$arrayOfHmisFormDataContractHmisFormDataContractItem instanceof \StructType\HmisFormDataContract) {
                throw new \InvalidArgumentException(sprintf('The HmisFormDataContract property can only contain items of \StructType\HmisFormDataContract, "%s" given', is_object($arrayOfHmisFormDataContractHmisFormDataContractItem) ? get_class($arrayOfHmisFormDataContractHmisFormDataContractItem) : gettype($arrayOfHmisFormDataContractHmisFormDataContractItem)), __LINE__);
            }
        }
        if (is_null($hmisFormDataContract) || (is_array($hmisFormDataContract) && empty($hmisFormDataContract))) {
            unset($this->HmisFormDataContract);
        } else {
            $this->HmisFormDataContract = $hmisFormDataContract;
        }
        return $this;
    }
    /**
     * Add item to HmisFormDataContract value
     * @throws \InvalidArgumentException
     * @param \StructType\HmisFormDataContract $item
     * @return \ArrayType\ArrayOfHmisFormDataContract
     */
    public function addToHmisFormDataContract(\StructType\HmisFormDataContract $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\HmisFormDataContract) {
            throw new \InvalidArgumentException(sprintf('The HmisFormDataContract property can only contain items of \StructType\HmisFormDataContract, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->HmisFormDataContract[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\HmisFormDataContract|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\HmisFormDataContract|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\HmisFormDataContract|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\HmisFormDataContract|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\HmisFormDataContract|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HmisFormDataContract
     */
    public function getAttributeName()
    {
        return 'HmisFormDataContract';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfHmisFormDataContract
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
