<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfNullableOfchar ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfNullableOfchar
 * @subpackage Arrays
 */
class ArrayOfNullableOfchar extends AbstractStructArrayBase
{
    /**
     * The char
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true | true
     * - type: tns:char
     * @var int[]
     */
    public $char;
    /**
     * Constructor method for ArrayOfNullableOfchar
     * @uses ArrayOfNullableOfchar::setChar()
     * @param int[] $char
     */
    public function __construct(array $char = array())
    {
        $this
            ->setChar($char);
    }
    /**
     * Get char value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int[]|null
     */
    public function getChar()
    {
        return isset($this->char) ? $this->char : null;
    }
    /**
     * Set char value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param int[] $char
     * @return \ArrayType\ArrayOfNullableOfchar
     */
    public function setChar(array $char = array())
    {
        foreach ($char as $arrayOfNullableOfcharCharItem) {
            // validation for constraint: itemType
            if (!is_numeric($arrayOfNullableOfcharCharItem)) {
                throw new \InvalidArgumentException(sprintf('The char property can only contain items of int, "%s" given', is_object($arrayOfNullableOfcharCharItem) ? get_class($arrayOfNullableOfcharCharItem) : gettype($arrayOfNullableOfcharCharItem)), __LINE__);
            }
        }
        if (is_null($char) || (is_array($char) && empty($char))) {
            unset($this->char);
        } else {
            $this->char = $char;
        }
        return $this;
    }
    /**
     * Add item to char value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \ArrayType\ArrayOfNullableOfchar
     */
    public function addToChar($item)
    {
        // validation for constraint: itemType
        if (!is_numeric($item)) {
            throw new \InvalidArgumentException(sprintf('The char property can only contain items of int, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->char[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return int|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return int|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return int|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return int|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return int|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string char
     */
    public function getAttributeName()
    {
        return 'char';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfNullableOfchar
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
