<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfNullableOfshort ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfNullableOfshort
 * @subpackage Arrays
 */
class ArrayOfNullableOfshort extends AbstractStructArrayBase
{
    /**
     * The short
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var int[]
     */
    public $short;
    /**
     * Constructor method for ArrayOfNullableOfshort
     * @uses ArrayOfNullableOfshort::setShort()
     * @param int[] $short
     */
    public function __construct(array $short = array())
    {
        $this
            ->setShort($short);
    }
    /**
     * Get short value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int[]|null
     */
    public function getShort()
    {
        return isset($this->short) ? $this->short : null;
    }
    /**
     * Set short value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param int[] $short
     * @return \ArrayType\ArrayOfNullableOfshort
     */
    public function setShort(array $short = array())
    {
        foreach ($short as $arrayOfNullableOfshortShortItem) {
            // validation for constraint: itemType
            if (!is_numeric($arrayOfNullableOfshortShortItem)) {
                throw new \InvalidArgumentException(sprintf('The short property can only contain items of short, "%s" given', is_object($arrayOfNullableOfshortShortItem) ? get_class($arrayOfNullableOfshortShortItem) : gettype($arrayOfNullableOfshortShortItem)), __LINE__);
            }
        }
        if (is_null($short) || (is_array($short) && empty($short))) {
            unset($this->short);
        } else {
            $this->short = $short;
        }
        return $this;
    }
    /**
     * Add item to short value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \ArrayType\ArrayOfNullableOfshort
     */
    public function addToShort($item)
    {
        // validation for constraint: itemType
        if (!is_numeric($item)) {
            throw new \InvalidArgumentException(sprintf('The short property can only contain items of short, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->short[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return int|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return int|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return int|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return int|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return int|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string short
     */
    public function getAttributeName()
    {
        return 'short';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfNullableOfshort
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
