<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfNullableOfunsignedByte ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfNullableOfunsignedByte
 * @subpackage Arrays
 */
class ArrayOfNullableOfunsignedByte extends AbstractStructArrayBase
{
    /**
     * The unsignedByte
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var string[]
     */
    public $unsignedByte;
    /**
     * Constructor method for ArrayOfNullableOfunsignedByte
     * @uses ArrayOfNullableOfunsignedByte::setUnsignedByte()
     * @param string[] $unsignedByte
     */
    public function __construct(array $unsignedByte = array())
    {
        $this
            ->setUnsignedByte($unsignedByte);
    }
    /**
     * Get unsignedByte value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string[]|null
     */
    public function getUnsignedByte()
    {
        return isset($this->unsignedByte) ? $this->unsignedByte : null;
    }
    /**
     * Set unsignedByte value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param string[] $unsignedByte
     * @return \ArrayType\ArrayOfNullableOfunsignedByte
     */
    public function setUnsignedByte(array $unsignedByte = array())
    {
        foreach ($unsignedByte as $arrayOfNullableOfunsignedByteUnsignedByteItem) {
            // validation for constraint: itemType
            if (!is_string($arrayOfNullableOfunsignedByteUnsignedByteItem)) {
                throw new \InvalidArgumentException(sprintf('The unsignedByte property can only contain items of unsignedByte, "%s" given', is_object($arrayOfNullableOfunsignedByteUnsignedByteItem) ? get_class($arrayOfNullableOfunsignedByteUnsignedByteItem) : gettype($arrayOfNullableOfunsignedByteUnsignedByteItem)), __LINE__);
            }
        }
        if (is_null($unsignedByte) || (is_array($unsignedByte) && empty($unsignedByte))) {
            unset($this->unsignedByte);
        } else {
            $this->unsignedByte = $unsignedByte;
        }
        return $this;
    }
    /**
     * Add item to unsignedByte value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfNullableOfunsignedByte
     */
    public function addToUnsignedByte($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The unsignedByte property can only contain items of unsignedByte, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->unsignedByte[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string unsignedByte
     */
    public function getAttributeName()
    {
        return 'unsignedByte';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfNullableOfunsignedByte
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
