<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfNullableOfunsignedLong ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfNullableOfunsignedLong
 * @subpackage Arrays
 */
class ArrayOfNullableOfunsignedLong extends AbstractStructArrayBase
{
    /**
     * The unsignedLong
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var int[]
     */
    public $unsignedLong;
    /**
     * Constructor method for ArrayOfNullableOfunsignedLong
     * @uses ArrayOfNullableOfunsignedLong::setUnsignedLong()
     * @param int[] $unsignedLong
     */
    public function __construct(array $unsignedLong = array())
    {
        $this
            ->setUnsignedLong($unsignedLong);
    }
    /**
     * Get unsignedLong value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int[]|null
     */
    public function getUnsignedLong()
    {
        return isset($this->unsignedLong) ? $this->unsignedLong : null;
    }
    /**
     * Set unsignedLong value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param int[] $unsignedLong
     * @return \ArrayType\ArrayOfNullableOfunsignedLong
     */
    public function setUnsignedLong(array $unsignedLong = array())
    {
        foreach ($unsignedLong as $arrayOfNullableOfunsignedLongUnsignedLongItem) {
            // validation for constraint: itemType
            if (!is_numeric($arrayOfNullableOfunsignedLongUnsignedLongItem)) {
                throw new \InvalidArgumentException(sprintf('The unsignedLong property can only contain items of unsignedLong, "%s" given', is_object($arrayOfNullableOfunsignedLongUnsignedLongItem) ? get_class($arrayOfNullableOfunsignedLongUnsignedLongItem) : gettype($arrayOfNullableOfunsignedLongUnsignedLongItem)), __LINE__);
            }
        }
        if (is_null($unsignedLong) || (is_array($unsignedLong) && empty($unsignedLong))) {
            unset($this->unsignedLong);
        } else {
            $this->unsignedLong = $unsignedLong;
        }
        return $this;
    }
    /**
     * Add item to unsignedLong value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \ArrayType\ArrayOfNullableOfunsignedLong
     */
    public function addToUnsignedLong($item)
    {
        // validation for constraint: itemType
        if (!is_numeric($item)) {
            throw new \InvalidArgumentException(sprintf('The unsignedLong property can only contain items of unsignedLong, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->unsignedLong[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return int|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return int|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return int|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return int|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return int|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string unsignedLong
     */
    public function getAttributeName()
    {
        return 'unsignedLong';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfNullableOfunsignedLong
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
