<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRecordStatusContract ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRecordStatusContract
 * @subpackage Arrays
 */
class ArrayOfRecordStatusContract extends AbstractStructArrayBase
{
    /**
     * The RecordStatusContract
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RecordStatusContract[]
     */
    public $RecordStatusContract;
    /**
     * Constructor method for ArrayOfRecordStatusContract
     * @uses ArrayOfRecordStatusContract::setRecordStatusContract()
     * @param \StructType\RecordStatusContract[] $recordStatusContract
     */
    public function __construct(array $recordStatusContract = array())
    {
        $this
            ->setRecordStatusContract($recordStatusContract);
    }
    /**
     * Get RecordStatusContract value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RecordStatusContract[]|null
     */
    public function getRecordStatusContract()
    {
        return isset($this->RecordStatusContract) ? $this->RecordStatusContract : null;
    }
    /**
     * Set RecordStatusContract value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RecordStatusContract[] $recordStatusContract
     * @return \ArrayType\ArrayOfRecordStatusContract
     */
    public function setRecordStatusContract(array $recordStatusContract = array())
    {
        foreach ($recordStatusContract as $arrayOfRecordStatusContractRecordStatusContractItem) {
            // validation for constraint: itemType
            if (!$arrayOfRecordStatusContractRecordStatusContractItem instanceof \StructType\RecordStatusContract) {
                throw new \InvalidArgumentException(sprintf('The RecordStatusContract property can only contain items of \StructType\RecordStatusContract, "%s" given', is_object($arrayOfRecordStatusContractRecordStatusContractItem) ? get_class($arrayOfRecordStatusContractRecordStatusContractItem) : gettype($arrayOfRecordStatusContractRecordStatusContractItem)), __LINE__);
            }
        }
        if (is_null($recordStatusContract) || (is_array($recordStatusContract) && empty($recordStatusContract))) {
            unset($this->RecordStatusContract);
        } else {
            $this->RecordStatusContract = $recordStatusContract;
        }
        return $this;
    }
    /**
     * Add item to RecordStatusContract value
     * @throws \InvalidArgumentException
     * @param \StructType\RecordStatusContract $item
     * @return \ArrayType\ArrayOfRecordStatusContract
     */
    public function addToRecordStatusContract(\StructType\RecordStatusContract $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RecordStatusContract) {
            throw new \InvalidArgumentException(sprintf('The RecordStatusContract property can only contain items of \StructType\RecordStatusContract, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RecordStatusContract[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RecordStatusContract|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RecordStatusContract|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RecordStatusContract|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RecordStatusContract|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RecordStatusContract|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RecordStatusContract
     */
    public function getAttributeName()
    {
        return 'RecordStatusContract';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfRecordStatusContract
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
