<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ExecutionResultContract' => '\\StructType\\ExecutionResultContract',
            'ArrayOfboolean' => '\\ArrayType\\ArrayOfboolean',
            'ArrayOfbyte' => '\\ArrayType\\ArrayOfbyte',
            'ArrayOfshort' => '\\ArrayType\\ArrayOfshort',
            'ArrayOfunsignedShort' => '\\ArrayType\\ArrayOfunsignedShort',
            'ArrayOfint' => '\\ArrayType\\ArrayOfint',
            'ArrayOfunsignedInt' => '\\ArrayType\\ArrayOfunsignedInt',
            'ArrayOflong' => '\\ArrayType\\ArrayOflong',
            'ArrayOfunsignedLong' => '\\ArrayType\\ArrayOfunsignedLong',
            'ArrayOffloat' => '\\ArrayType\\ArrayOffloat',
            'ArrayOfdouble' => '\\ArrayType\\ArrayOfdouble',
            'ArrayOfdecimal' => '\\ArrayType\\ArrayOfdecimal',
            'ArrayOfchar' => '\\ArrayType\\ArrayOfchar',
            'ArrayOfstring' => '\\ArrayType\\ArrayOfstring',
            'ArrayOfdateTime' => '\\ArrayType\\ArrayOfdateTime',
            'ArrayOfduration' => '\\ArrayType\\ArrayOfduration',
            'ArrayOfguid' => '\\ArrayType\\ArrayOfguid',
            'ArrayOfKeyValueOfstringanyType' => '\\ArrayType\\ArrayOfKeyValueOfstringanyType',
            'KeyValueOfstringanyType' => '\\StructType\\KeyValueOfstringanyType',
            'ArrayOfKeyValueOfstringArrayOfHmisFormDataContractNObIUIam' => '\\ArrayType\\ArrayOfKeyValueOfstringArrayOfHmisFormDataContractNObIUIam',
            'KeyValueOfstringArrayOfHmisFormDataContractNObIUIam' => '\\StructType\\KeyValueOfstringArrayOfHmisFormDataContractNObIUIam',
            'ArrayOfArrayOfKeyValueOfstringanyType' => '\\ArrayType\\ArrayOfArrayOfKeyValueOfstringanyType',
            'SchemaContract' => '\\StructType\\SchemaContract',
            'ArrayOfFormSchemaContract' => '\\ArrayType\\ArrayOfFormSchemaContract',
            'FormSchemaContract' => '\\StructType\\FormSchemaContract',
            'ArrayOfFormFieldSchemaContract' => '\\ArrayType\\ArrayOfFormFieldSchemaContract',
            'FormFieldSchemaContract' => '\\StructType\\FormFieldSchemaContract',
            'ArrayOfGridSchemaContract' => '\\ArrayType\\ArrayOfGridSchemaContract',
            'GridSchemaContract' => '\\StructType\\GridSchemaContract',
            'ArrayOfGridFieldSchemaContract' => '\\ArrayType\\ArrayOfGridFieldSchemaContract',
            'GridFieldSchemaContract' => '\\StructType\\GridFieldSchemaContract',
            'RecordStatusesContract' => '\\StructType\\RecordStatusesContract',
            'ArrayOfRecordStatusContract' => '\\ArrayType\\ArrayOfRecordStatusContract',
            'RecordStatusContract' => '\\StructType\\RecordStatusContract',
            'HmisFormDataContract' => '\\StructType\\HmisFormDataContract',
            'ArrayOfHmisFormDataContract' => '\\ArrayType\\ArrayOfHmisFormDataContract',
            'HmisBinaryDataContract' => '\\StructType\\HmisBinaryDataContract',
            'KeyIDResultContract' => '\\StructType\\KeyIDResultContract',
            'InsuranceAreaDataContract' => '\\StructType\\InsuranceAreaDataContract',
            'ArrayOfInsuranceAreaContract' => '\\ArrayType\\ArrayOfInsuranceAreaContract',
            'InsuranceAreaContract' => '\\StructType\\InsuranceAreaContract',
            'FormDataResultContract' => '\\StructType\\FormDataResultContract',
            'GridRowDataContract' => '\\StructType\\GridRowDataContract',
            'GridDataContract' => '\\StructType\\GridDataContract',
            'Login' => '\\StructType\\Login',
            'LoginResponse' => '\\StructType\\LoginResponse',
            'GetAllSchemas' => '\\StructType\\GetAllSchemas',
            'GetAllSchemasResponse' => '\\StructType\\GetAllSchemasResponse',
            'GetFormSchema' => '\\StructType\\GetFormSchema',
            'GetFormSchemaResponse' => '\\StructType\\GetFormSchemaResponse',
            'GetAllStatuses' => '\\StructType\\GetAllStatuses',
            'GetAllStatusesResponse' => '\\StructType\\GetAllStatusesResponse',
            'AddFormGridData' => '\\StructType\\AddFormGridData',
            'AddFormGridDataResponse' => '\\StructType\\AddFormGridDataResponse',
            'FillFormData' => '\\StructType\\FillFormData',
            'FillFormDataResponse' => '\\StructType\\FillFormDataResponse',
            'ClearFormData' => '\\StructType\\ClearFormData',
            'ClearFormDataResponse' => '\\StructType\\ClearFormDataResponse',
            'AddRowData' => '\\StructType\\AddRowData',
            'AddRowDataResponse' => '\\StructType\\AddRowDataResponse',
            'AddGridData' => '\\StructType\\AddGridData',
            'AddGridDataResponse' => '\\StructType\\AddGridDataResponse',
            'GetRegionDistricts' => '\\StructType\\GetRegionDistricts',
            'GetRegionDistrictsResponse' => '\\StructType\\GetRegionDistrictsResponse',
            'ClearGridData' => '\\StructType\\ClearGridData',
            'ClearGridDataResponse' => '\\StructType\\ClearGridDataResponse',
            'RemoveRowData' => '\\StructType\\RemoveRowData',
            'RemoveRowDataResponse' => '\\StructType\\RemoveRowDataResponse',
            'ModifyRowData' => '\\StructType\\ModifyRowData',
            'ModifyRowDataResponse' => '\\StructType\\ModifyRowDataResponse',
            'FindFormData' => '\\StructType\\FindFormData',
            'FindFormDataResponse' => '\\StructType\\FindFormDataResponse',
            'GetFormData' => '\\StructType\\GetFormData',
            'GetFormDataResponse' => '\\StructType\\GetFormDataResponse',
            'GetRowData' => '\\StructType\\GetRowData',
            'GetRowDataResponse' => '\\StructType\\GetRowDataResponse',
            'GetGridData' => '\\StructType\\GetGridData',
            'GetGridDataResponse' => '\\StructType\\GetGridDataResponse',
            'StringBuilder' => '\\StructType\\StringBuilder',
            'HmisTextData' => '\\StructType\\HmisTextData',
            'HmisBinaryData' => '\\StructType\\HmisBinaryData',
            'BigInteger' => '\\StructType\\BigInteger',
            'ArrayOfBigInteger' => '\\ArrayType\\ArrayOfBigInteger',
            'Complex' => '\\StructType\\Complex',
            'ArrayOfComplex' => '\\ArrayType\\ArrayOfComplex',
            'ArrayOfNullableOfboolean' => '\\ArrayType\\ArrayOfNullableOfboolean',
            'ArrayOfNullableOfbyte' => '\\ArrayType\\ArrayOfNullableOfbyte',
            'ArrayOfNullableOfunsignedByte' => '\\ArrayType\\ArrayOfNullableOfunsignedByte',
            'ArrayOfNullableOfshort' => '\\ArrayType\\ArrayOfNullableOfshort',
            'ArrayOfNullableOfunsignedShort' => '\\ArrayType\\ArrayOfNullableOfunsignedShort',
            'ArrayOfNullableOfint' => '\\ArrayType\\ArrayOfNullableOfint',
            'ArrayOfNullableOfunsignedInt' => '\\ArrayType\\ArrayOfNullableOfunsignedInt',
            'ArrayOfNullableOflong' => '\\ArrayType\\ArrayOfNullableOflong',
            'ArrayOfNullableOfunsignedLong' => '\\ArrayType\\ArrayOfNullableOfunsignedLong',
            'ArrayOfNullableOffloat' => '\\ArrayType\\ArrayOfNullableOffloat',
            'ArrayOfNullableOfdouble' => '\\ArrayType\\ArrayOfNullableOfdouble',
            'ArrayOfNullableOfdecimal' => '\\ArrayType\\ArrayOfNullableOfdecimal',
            'ArrayOfNullableOfchar' => '\\ArrayType\\ArrayOfNullableOfchar',
            'ArrayOfNullableOfdateTime' => '\\ArrayType\\ArrayOfNullableOfdateTime',
            'ArrayOfNullableOfduration' => '\\ArrayType\\ArrayOfNullableOfduration',
            'ArrayOfNullableOfguid' => '\\ArrayType\\ArrayOfNullableOfguid',
            'ArrayOfNullableOfBigIntegerf_PlnZ8aM' => '\\ArrayType\\ArrayOfNullableOfBigIntegerf_PlnZ8aM',
            'ArrayOfNullableOfComplexf_PlnZ8aM' => '\\ArrayType\\ArrayOfNullableOfComplexf_PlnZ8aM',
        );
    }
}
