<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BigInteger StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:BigInteger
 * @subpackage Structs
 */
class BigInteger extends AbstractStructBase
{
    /**
     * The _bits
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfunsignedInt
     */
    public $_bits;
    /**
     * The _sign
     * @var int
     */
    public $_sign;
    /**
     * Constructor method for BigInteger
     * @uses BigInteger::set_bits()
     * @uses BigInteger::set_sign()
     * @param \ArrayType\ArrayOfunsignedInt $_bits
     * @param int $_sign
     */
    public function __construct(\ArrayType\ArrayOfunsignedInt $_bits = null, $_sign = null)
    {
        $this
            ->set_bits($_bits)
            ->set_sign($_sign);
    }
    /**
     * Get _bits value
     * @return \ArrayType\ArrayOfunsignedInt|null
     */
    public function get_bits()
    {
        return $this->_bits;
    }
    /**
     * Set _bits value
     * @param \ArrayType\ArrayOfunsignedInt $_bits
     * @return \StructType\BigInteger
     */
    public function set_bits(\ArrayType\ArrayOfunsignedInt $_bits = null)
    {
        $this->_bits = $_bits;
        return $this;
    }
    /**
     * Get _sign value
     * @return int|null
     */
    public function get_sign()
    {
        return $this->_sign;
    }
    /**
     * Set _sign value
     * @param int $_sign
     * @return \StructType\BigInteger
     */
    public function set_sign($_sign = null)
    {
        // validation for constraint: int
        if (!is_null($_sign) && !is_numeric($_sign)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($_sign)), __LINE__);
        }
        $this->_sign = $_sign;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BigInteger
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
