<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FormDataResultContract StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:FormDataResultContract
 * @subpackage Structs
 */
class FormDataResultContract extends ExecutionResultContract
{
    /**
     * The FormData
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\HmisFormDataContract
     */
    public $FormData;
    /**
     * Constructor method for FormDataResultContract
     * @uses FormDataResultContract::setFormData()
     * @param \StructType\HmisFormDataContract $formData
     */
    public function __construct(\StructType\HmisFormDataContract $formData = null)
    {
        $this
            ->setFormData($formData);
    }
    /**
     * Get FormData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\HmisFormDataContract|null
     */
    public function getFormData()
    {
        return isset($this->FormData) ? $this->FormData : null;
    }
    /**
     * Set FormData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\HmisFormDataContract $formData
     * @return \StructType\FormDataResultContract
     */
    public function setFormData(\StructType\HmisFormDataContract $formData = null)
    {
        if (is_null($formData) || (is_array($formData) && empty($formData))) {
            unset($this->FormData);
        } else {
            $this->FormData = $formData;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\FormDataResultContract
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
