<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GridFieldSchemaContract StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:GridFieldSchemaContract
 * @subpackage Structs
 */
class GridFieldSchemaContract extends ExecutionResultContract
{
    /**
     * The Alias
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Alias;
    /**
     * The BillingAlias
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $BillingAlias;
    /**
     * The DataType
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DataType;
    /**
     * The IsKeyField
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $IsKeyField;
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Name;
    /**
     * The OrderIndex
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $OrderIndex;
    /**
     * The Visible
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $Visible;
    /**
     * Constructor method for GridFieldSchemaContract
     * @uses GridFieldSchemaContract::setAlias()
     * @uses GridFieldSchemaContract::setBillingAlias()
     * @uses GridFieldSchemaContract::setDataType()
     * @uses GridFieldSchemaContract::setIsKeyField()
     * @uses GridFieldSchemaContract::setName()
     * @uses GridFieldSchemaContract::setOrderIndex()
     * @uses GridFieldSchemaContract::setVisible()
     * @param string $alias
     * @param string $billingAlias
     * @param string $dataType
     * @param bool $isKeyField
     * @param string $name
     * @param int $orderIndex
     * @param bool $visible
     */
    public function __construct($alias = null, $billingAlias = null, $dataType = null, $isKeyField = null, $name = null, $orderIndex = null, $visible = null)
    {
        $this
            ->setAlias($alias)
            ->setBillingAlias($billingAlias)
            ->setDataType($dataType)
            ->setIsKeyField($isKeyField)
            ->setName($name)
            ->setOrderIndex($orderIndex)
            ->setVisible($visible);
    }
    /**
     * Get Alias value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAlias()
    {
        return isset($this->Alias) ? $this->Alias : null;
    }
    /**
     * Set Alias value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $alias
     * @return \StructType\GridFieldSchemaContract
     */
    public function setAlias($alias = null)
    {
        // validation for constraint: string
        if (!is_null($alias) && !is_string($alias)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($alias)), __LINE__);
        }
        if (is_null($alias) || (is_array($alias) && empty($alias))) {
            unset($this->Alias);
        } else {
            $this->Alias = $alias;
        }
        return $this;
    }
    /**
     * Get BillingAlias value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBillingAlias()
    {
        return isset($this->BillingAlias) ? $this->BillingAlias : null;
    }
    /**
     * Set BillingAlias value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $billingAlias
     * @return \StructType\GridFieldSchemaContract
     */
    public function setBillingAlias($billingAlias = null)
    {
        // validation for constraint: string
        if (!is_null($billingAlias) && !is_string($billingAlias)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($billingAlias)), __LINE__);
        }
        if (is_null($billingAlias) || (is_array($billingAlias) && empty($billingAlias))) {
            unset($this->BillingAlias);
        } else {
            $this->BillingAlias = $billingAlias;
        }
        return $this;
    }
    /**
     * Get DataType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataType()
    {
        return isset($this->DataType) ? $this->DataType : null;
    }
    /**
     * Set DataType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataType
     * @return \StructType\GridFieldSchemaContract
     */
    public function setDataType($dataType = null)
    {
        // validation for constraint: string
        if (!is_null($dataType) && !is_string($dataType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dataType)), __LINE__);
        }
        if (is_null($dataType) || (is_array($dataType) && empty($dataType))) {
            unset($this->DataType);
        } else {
            $this->DataType = $dataType;
        }
        return $this;
    }
    /**
     * Get IsKeyField value
     * @return bool|null
     */
    public function getIsKeyField()
    {
        return $this->IsKeyField;
    }
    /**
     * Set IsKeyField value
     * @param bool $isKeyField
     * @return \StructType\GridFieldSchemaContract
     */
    public function setIsKeyField($isKeyField = null)
    {
        $this->IsKeyField = $isKeyField;
        return $this;
    }
    /**
     * Get Name value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getName()
    {
        return isset($this->Name) ? $this->Name : null;
    }
    /**
     * Set Name value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $name
     * @return \StructType\GridFieldSchemaContract
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        if (is_null($name) || (is_array($name) && empty($name))) {
            unset($this->Name);
        } else {
            $this->Name = $name;
        }
        return $this;
    }
    /**
     * Get OrderIndex value
     * @return int|null
     */
    public function getOrderIndex()
    {
        return $this->OrderIndex;
    }
    /**
     * Set OrderIndex value
     * @param int $orderIndex
     * @return \StructType\GridFieldSchemaContract
     */
    public function setOrderIndex($orderIndex = null)
    {
        // validation for constraint: int
        if (!is_null($orderIndex) && !is_numeric($orderIndex)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($orderIndex)), __LINE__);
        }
        $this->OrderIndex = $orderIndex;
        return $this;
    }
    /**
     * Get Visible value
     * @return bool|null
     */
    public function getVisible()
    {
        return $this->Visible;
    }
    /**
     * Set Visible value
     * @param bool $visible
     * @return \StructType\GridFieldSchemaContract
     */
    public function setVisible($visible = null)
    {
        $this->Visible = $visible;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GridFieldSchemaContract
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
