<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HmisBinaryData StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:HmisBinaryData
 * @subpackage Structs
 */
class HmisBinaryData extends AbstractStructBase
{
    /**
     * The Bytes
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Bytes;
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Name;
    /**
     * Constructor method for HmisBinaryData
     * @uses HmisBinaryData::setBytes()
     * @uses HmisBinaryData::setName()
     * @param string $bytes
     * @param string $name
     */
    public function __construct($bytes = null, $name = null)
    {
        $this
            ->setBytes($bytes)
            ->setName($name);
    }
    /**
     * Get Bytes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBytes()
    {
        return isset($this->Bytes) ? $this->Bytes : null;
    }
    /**
     * Set Bytes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $bytes
     * @return \StructType\HmisBinaryData
     */
    public function setBytes($bytes = null)
    {
        // validation for constraint: string
        if (!is_null($bytes) && !is_string($bytes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($bytes)), __LINE__);
        }
        if (is_null($bytes) || (is_array($bytes) && empty($bytes))) {
            unset($this->Bytes);
        } else {
            $this->Bytes = $bytes;
        }
        return $this;
    }
    /**
     * Get Name value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getName()
    {
        return isset($this->Name) ? $this->Name : null;
    }
    /**
     * Set Name value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $name
     * @return \StructType\HmisBinaryData
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        if (is_null($name) || (is_array($name) && empty($name))) {
            unset($this->Name);
        } else {
            $this->Name = $name;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\HmisBinaryData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
