<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HmisTextData StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:HmisTextData
 * @subpackage Structs
 */
class HmisTextData extends AbstractStructBase
{
    /**
     * The TextData
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringBuilder
     */
    public $TextData;
    /**
     * Constructor method for HmisTextData
     * @uses HmisTextData::setTextData()
     * @param \StructType\StringBuilder $textData
     */
    public function __construct(\StructType\StringBuilder $textData = null)
    {
        $this
            ->setTextData($textData);
    }
    /**
     * Get TextData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringBuilder|null
     */
    public function getTextData()
    {
        return isset($this->TextData) ? $this->TextData : null;
    }
    /**
     * Set TextData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringBuilder $textData
     * @return \StructType\HmisTextData
     */
    public function setTextData(\StructType\StringBuilder $textData = null)
    {
        if (is_null($textData) || (is_array($textData) && empty($textData))) {
            unset($this->TextData);
        } else {
            $this->TextData = $textData;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\HmisTextData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
